export interface Newable<T> {
    new (...args: any[]): T;
}
export interface Abstract<T> {
    prototype: T;
}
export declare type ServiceIdentifier<T> = (string | symbol | Newable<T> | Abstract<T>);
export declare function InterfaceSymbol<T extends Object>(): symbol;
export declare class Container {
    private _map;
    get<T>(key: ServiceIdentifier<T> | ServiceIdentifier<T>[]): unknown;
    bind<T>(serviceIdentifier: ServiceIdentifier<T>, constructor: Newable<T>, params?: any[]): void;
    bindToConstant<T>(serviceIdentifier: ServiceIdentifier<T>, constant: T): void;
    /**
     * Bind the implementations of the class to the class.
     * @param constructor
     * @param params
     * @param serviceIdentifiers
     */
    bindToImplements<T>(constructor: Newable<T>, params?: any[], serviceIdentifiers?: ServiceIdentifier<T>[]): void;
    bindToFactory<T>(serviceIdentifier: ServiceIdentifier<T>, factory: (container: Container) => T): void;
    resolve<T>(service: Newable<T>, params?: any[]): T;
    resolveFactory<T>(service: Newable<T>, params?: any[]): Newable<T>;
}
